-- File: ledctrl.vhd
-- Generated by MyHDL 1.0dev
-- Date: Tue Apr  5 16:37:34 2016


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use std.textio.all;

use work.pck_myhdl_10.all;

entity ledctrl is
    port (
        clk: in std_logic;
        reset: in std_logic;
        pattern: in std_logic;
        go: in std_logic;
        stop: in std_logic;
        led_drv: out unsigned(7 downto 0)
    );
end entity ledctrl;
-- LED control FSM.
-- 
-- clk -- clock input
-- reset -- active low reset
-- pattern -- the pattern of LEDs to illuminate
-- go -- go input
-- stop -- stop input

architecture MyHDL of ledctrl is


type t_enum_t_State_1 is (
    IDLE,
    ILLUMINATE,
    DONE
);

signal state: t_enum_t_State_1;

begin





LEDCTRL_FSM: process (clk) is
begin
    if rising_edge(clk) then
        if (reset = '0') then
            state <= IDLE;
            led_drv <= to_unsigned(0, 8);
        else
            case state is
                when IDLE =>
                    if bool(go) then
                        led_drv <= tern_op(cond => bool(pattern), if_true => to_unsigned(170, 8), if_false => to_unsigned(85, 8));
                        state <= ILLUMINATE;
                    end if;
                when ILLUMINATE =>
                    if bool(stop) then
                        led_drv <= to_unsigned(255, 8);
                        state <= DONE;
                    end if;
                when DONE =>
                    if (not bool(stop)) then
                        led_drv <= to_unsigned(0, 8);
                        state <= IDLE;
                    end if;
                when others =>
                    assert False report "End of Simulation" severity Failure;
            end case;
        end if;
    end if;
end process LEDCTRL_FSM;

end architecture MyHDL;
